# Class Node represent nodes in the graph. Every node contains a
# position (x,y) in the grid
# and a rotation in degree where
# 0 = North
# 90 = East
# 280 = South
# 270 = West
# all degrees must be between 0 and 360

# attributes are set to private such that they cannot be overwritten and there is no problem with the hash

class Node:
    def __init__(self,x,y,g):
        self._x = x
        self._y = y
        self._g = g

    @property
    def x(self):
        return self._x

    @property
    def y(self):
        return self._y

    @property
    def g(self):
        return self._g


    def __eq__(self, other):
        return self.__class__ == other.__class__ and self.x == other.x and self.y == other.y and self.g == other.g


    def __hash__(self):
        return (((self.x * 397) ** self.y) * 397) **self.g

    def __str__(self):
        return "[(" + str(self.x) + ", " + str(self.y) + ")" + "," + str(self.g) + "]"
